'--------------------------------------------------------------------------------

'                                Using ADO 2.0 Datasources 
'                                        Created 5/13/08
'                                           Ron Kessler



'--------------------------------------------------------------------------------

'UPDATED 4/3/09

'4/3/09  Added external CSS


'This app uses a dropdown to show customer names. When we pick on (use C.Weed or Joe Tran)
'the history of their purchases show up in the grid.


Imports System.Data
Imports System.Data.SqlClient


Partial Class _Default
    Inherits System.Web.UI.Page

    

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        SelectCustomer()

    End Sub

    Private Sub SelectCustomer()

        '---by using the the DataSource Class, we do not need Connection Objects, DataAdapter, or DataSet controls
        If Not IsPostBack Then
            'Try
            Dim connString As String = ConfigurationManager.ConnectionStrings("customers-05").ConnectionString

            Dim dsCustomers As New SqlDataSource

            With dsCustomers
                .ConnectionString = connString
                .DataSourceMode = SqlDataSourceMode.DataReader
                .SelectCommand = "Select * From Customers ORDER BY Name"
            End With

            With ddlNames
                .DataSource = dsCustomers
                .DataTextField = "Name"
                .DataValueField = "CustID"
                .AutoPostBack = True
            End With

            '---make it so!
            ddlNames.DataBind()

            'Catch ex As Exception
            '    Response.Redirect("errorpage.aspx")
            'Finally


            'End Try
        End If

    End Sub

    Private Sub FillMyGrid()

        Dim connString As String = ConfigurationManager.ConnectionStrings("customers-05").ConnectionString
        Dim myDataSource As New SqlDataSource

        With myDataSource
            .ConnectionString = connString
            .DataSourceMode = SqlDataSourceMode.DataSet
            .SelectCommand = "SELECT * FROM Orders WHERE CustID = @CustID"
            .SelectParameters.Add("CustID", ddlNames.SelectedValue)
            .DataBind()
        End With


        With GridView1
            .AutoGenerateColumns = True
            .DataSource = myDataSource
            .AllowSorting = True
            .AllowPaging = True
            .Caption = "Customer Orders Summary"
            .CaptionAlign = TableCaptionAlign.Top
            .DataBind()
        End With

    End Sub

   
    Protected Sub ddlNames_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ddlNames.SelectedIndexChanged
        FillMyGrid()
    End Sub
End Class
